import { Schema, Node as ProsemirrorNode } from 'prosemirror-model';
import { EditorView, Decoration } from 'prosemirror-view';
import { Plugin } from 'prosemirror-state';
import { Editor } from './Editor';
import { Extensions, RawCommands } from './types';
export default class ExtensionManager {
    editor: Editor;
    schema: Schema;
    extensions: Extensions;
    constructor(extensions: Extensions, editor: Editor);
    get commands(): RawCommands;
    get plugins(): Plugin[];
    get attributes(): import("./types").ExtensionAttribute[];
    get nodeViews(): {
        [k: string]: (node: ProsemirrorNode, view: EditorView, getPos: (() => number) | boolean, decorations: Decoration[]) => {} | import("prosemirror-view").NodeView<any>;
    };
    get textSerializers(): {
        [k: string]: (props: {
            node: ProsemirrorNode;
        }) => string | undefined;
    };
}
